﻿-- Create Date : 4/20/2009 11:54:36 AM

FriendXPBarUserXP = {};
FriendXPBarUserXPMax = {};


function FriendXPBar_GetXP()	
	if playername ~= nil then 
		if FriendXPBarUserXP[playername] ~= nil then
			lblTargetname:SetText(playername);
			lblXP:SetText(FriendXPBarUserXP[playername] .. " / " .. FriendXPBarUserXPMax[playername] .. " (" .. floor( (FriendXPBarUserXP[playername]/FriendXPBarUserXPMax[playername]) * 100) .. "%) XP");
		else 
			lblTargetname:SetText(playername);
			lblXP:SetText("Sorry, no data collected");
		end
	end
end

function FriendXPBar_HandleCommand(cmd)
	
	--Show/Hide the XP Bar
	if strlower(cmd) == "hide" then
		Frame1:Hide();
	elseif strlower(cmd) == "show" then
		Frame1:Show();
	elseif strlower(cmd) == "target" then
		playername = UnitName("target")
	elseif strlower(cmd) == "update" then
		local xp = UnitXP("player");
		local xpMax = UnitXPMax("player");
		SendAddonMessage("FRIENDXPBAR_XP",xp,"PARTY");
		SendAddonMessage("FRIENDXPBAR_XPMAX",xpMax,"PARTY");
	end
	
	--Manual Update
	FriendXPBar_GetXP();
end

function FriendXPBar_OnLoad()
	--Bind slash command
	SLASH_FRIENDXPBAR1 = "/fxp";
	SlashCmdList["FRIENDXPBAR"] = FriendXPBar_HandleCommand;
	
	--Bind events and set handler
	Frame1:RegisterEvent("CHAT_MSG_ADDON");
	Frame1:RegisterEvent("CHAT_MSG_COMBAT_XP_GAIN");
	Frame1:RegisterEvent("PLAYER_ENTERING_WORLD");
	Frame1:RegisterEvent("PARTY_MEMBERS_CHANGED");
	
	Frame1:SetScript("OnEvent",FriendXPBar_eventHandler);
	if playername ~= nil then 
		lblTargetname:SetText(playername);
	end
	
end

function FriendXPBar_eventHandler(self, event, ...)
	if event == "CHAT_MSG_ADDON" then
		--Break down the message
		local prefix, message, type, sender = ...;
		
		if prefix == "FRIENDXPBAR_XP" then
			FriendXPBarUserXP[sender] = message;
			--We have recieved a peice of info telling us the current XP
		end
		
		if prefix == "FRIENDXPBAR_XPMAX" then
			--We have recieved a peice of info telling us the max XP
			FriendXPBarUserXPMax[sender] = message;
			FriendXPBar_GetXP();
		end
		
	elseif event == "CHAT_MSG_COMBAT_XP_GAIN" then
		--We have gained some XP, so lets tell everyone
		local xp = UnitXP("player");
		local xpMax = UnitXPMax("player");
		SendAddonMessage("FRIENDXPBAR_XP",xp,"PARTY");
		SendAddonMessage("FRIENDXPBAR_XPMAX",xpMax,"PARTY");
		lblOwnXPLeft:SetText(xpMax-xp .. "XP Left to level");
	elseif event == "PLAYER_ENTERING_WORLD" then
		local xp = UnitXP("player");
		local xpMax = UnitXPMax("player");
		SendAddonMessage("FRIENDXPBAR_XP",xp,"PARTY");
		SendAddonMessage("FRIENDXPBAR_XPMAX",xpMax,"PARTY");
		lblOwnXPLeft:SetText(xpMax-xp .. "XP Left to level");
	elseif event == "PARTY_MEMBERS_CHANGED" then
		local xp = UnitXP("player");
		local xpMax = UnitXPMax("player");
		SendAddonMessage("FRIENDXPBAR_XP",xp,"PARTY");
		SendAddonMessage("FRIENDXPBAR_XPMAX",xpMax,"PARTY");
		lblOwnXPLeft:SetText(xpMax-xp .. "XP Left to level");
	end
end
